<html>
<head>
<title>OGRE: Ogre::PlaneOptimalShadowCameraSetup Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html">PlaneOptimalShadowCameraSetup</a></div>
<h1>Ogre::PlaneOptimalShadowCameraSetup Class Reference</h1><!-- doxytag: class="Ogre::PlaneOptimalShadowCameraSetup" --><!-- doxytag: inherits="Ogre::ShadowCameraSetup" -->Implements the plane optimal shadow camera algorithm.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html">OgreShadowCameraSetupPlaneOptimal.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::PlaneOptimalShadowCameraSetup:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1PlaneOptimalShadowCameraSetup-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#84aeb5d693cf9235080fc84031ec881f">PlaneOptimalShadowCameraSetup</a> (<a class="el" href="classOgre_1_1MovablePlane.html">MovablePlane</a> *plane)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor -- requires a plane of interest.  <a href="#84aeb5d693cf9235080fc84031ec881f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#0fdd507e53ed2fecb42080c9c9fe85ec">~PlaneOptimalShadowCameraSetup</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destructor.  <a href="#0fdd507e53ed2fecb42080c9c9fe85ec"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#c5f4e3dc347c87d35244064665448937">getShadowCamera</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam, const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *vp, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *texCam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns shadow camera configured to get 1-1 homography between screen and shadow map when restricted to plane.  <a href="#c5f4e3dc347c87d35244064665448937"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#f08678d2dee8c44a9467aacae33bac39">PlaneOptimalShadowCameraSetup</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor is private.  <a href="#f08678d2dee8c44a9467aacae33bac39"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#863c932c61c929cbb80cd6fe5c56fad1">computeConstrainedProjection</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;pinhole, const std::vector&lt; <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &gt; &amp;fpoint, const std::vector&lt; <a class="el" href="classOgre_1_1Vector2.html">Vector2</a> &gt; &amp;constraint) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">helper function computing projection matrix given constraints  <a href="#863c932c61c929cbb80cd6fe5c56fad1"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1MovablePlane.html">MovablePlane</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#f78baef232d987b714fe27a4f5e70b14">m_plane</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">pointer to plane of interest  <a href="#f78baef232d987b714fe27a4f5e70b14"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Implements the plane optimal shadow camera algorithm. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Given a plane of interest, it is possible to set up the shadow camera matrix such that the mapping between screen and shadow map is the identity (when restricted to pixels that view the plane of interest). Therefore, if the shadow map resolution matches the screen space resolution (of the seen planar receiver), we can get pixel perfect shadowing on the plane. Off the plane, the shadowing is not guaranteed to be perfect and will likely exhibit the usual sampling artifacts associated with shadow mapping. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Important: this routine requires double-precision calculations. When you are running under Direct3D, you must ensure that you set the floating point mode to 'Consistent' rather than 'Fastest' to ensure this precision. This does allegedly come with some performance cost but when measuring it appears to be negligible in modern systems for normal usage. <p>
Second important note: this projection also only works for lights with a finite position. Therefore you cannot use it for directional lights at this time. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html#l00056">56</a> of file <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html">OgreShadowCameraSetupPlaneOptimal.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="f08678d2dee8c44a9467aacae33bac39"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::PlaneOptimalShadowCameraSetup" ref="f08678d2dee8c44a9467aacae33bac39" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::PlaneOptimalShadowCameraSetup::PlaneOptimalShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default constructor is private. 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html#l00061">61</a> of file <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html">OgreShadowCameraSetupPlaneOptimal.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="84aeb5d693cf9235080fc84031ec881f"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::PlaneOptimalShadowCameraSetup" ref="84aeb5d693cf9235080fc84031ec881f" args="(MovablePlane *plane)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::PlaneOptimalShadowCameraSetup::PlaneOptimalShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MovablePlane.html">MovablePlane</a> *&nbsp;</td>
          <td class="paramname"> <em>plane</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor -- requires a plane of interest. 
<p>

</div>
</div><p>
<a class="anchor" name="0fdd507e53ed2fecb42080c9c9fe85ec"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::~PlaneOptimalShadowCameraSetup" ref="0fdd507e53ed2fecb42080c9c9fe85ec" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::PlaneOptimalShadowCameraSetup::~PlaneOptimalShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destructor. 
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="863c932c61c929cbb80cd6fe5c56fad1"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::computeConstrainedProjection" ref="863c932c61c929cbb80cd6fe5c56fad1" args="(const Vector4 &amp;pinhole, const std::vector&lt; Vector4 &gt; &amp;fpoint, const std::vector&lt; Vector2 &gt; &amp;constraint) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::PlaneOptimalShadowCameraSetup::computeConstrainedProjection           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>pinhole</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>fpoint</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="classOgre_1_1Vector2.html">Vector2</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>constraint</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
helper function computing projection matrix given constraints 
<p>

</div>
</div><p>
<a class="anchor" name="c5f4e3dc347c87d35244064665448937"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::getShadowCamera" ref="c5f4e3dc347c87d35244064665448937" args="(const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::PlaneOptimalShadowCameraSetup::getShadowCamera           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&nbsp;</td>
          <td class="paramname"> <em>vp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>texCam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns shadow camera configured to get 1-1 homography between screen and shadow map when restricted to plane. 
<p>

<p>Implements <a class="el" href="classOgre_1_1ShadowCameraSetup.html#672a8fa796007d122d3555b09c611d2e">Ogre::ShadowCameraSetup</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="f78baef232d987b714fe27a4f5e70b14"></a><!-- doxytag: member="Ogre::PlaneOptimalShadowCameraSetup::m_plane" ref="f78baef232d987b714fe27a4f5e70b14" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MovablePlane.html">MovablePlane</a>* <a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#f78baef232d987b714fe27a4f5e70b14">Ogre::PlaneOptimalShadowCameraSetup::m_plane</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
pointer to plane of interest 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html#l00059">59</a> of file <a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html">OgreShadowCameraSetupPlaneOptimal.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCameraSetupPlaneOptimal_8h-source.html">OgreShadowCameraSetupPlaneOptimal.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:36 2008
</p>
</body>
</html>
